%MACRO construire_liste;

FILENAME pipedir pipe 'dir "C:\Program Files" /S' lrecl=5000;

DATA work.liste_fichiers_C_LRR (DROP=descr_ligne_fichier);
	INFILE pipedir TRUNCOVER;
	INPUT descr_ligne_fichier $CHAR1000.;
	LENGTH repertoire $1000;
	RETAIN repertoire;
	
	descr_ligne_fichier = COMPRESS(descr_ligne_fichier,"");
	descr_ligne_fichier = TRANSLATE(descr_ligne_fichier,"","ӷ؀"); 
	descr_ligne_fichier = TRANSLATE(SUBSTR(descr_ligne_fichier,1,10),"/","-")||SUBSTR(descr_ligne_fichier,11,990);

	IF CATS(descr_ligne_fichier) ='' 
		OR INDEX(UPCASE(descr_ligne_fichier),'<REP>') 
		OR INDEX(UPCASE(descr_ligne_fichier),'LE VOLUME') 
		OR INDEX(UPCASE(descr_ligne_fichier),"LE NUMRO DE SRIE") 
		OR INDEX(UPCASE(descr_ligne_fichier),"TOTAL DES FICHIERS") 
		OR INDEX(UPCASE(descr_ligne_fichier),"FICHIER(S)")  
		OR INDEX(UPCASE(descr_ligne_fichier),"OCTETS LIBRES") 
			THEN DELETE;

	IF LEFT(UPCASE(descr_ligne_fichier))=:'RPERTOIRE DE' THEN DO
		repertoire = LEFT(SUBSTR(descr_ligne_fichier,INDEX(UPCASE(descr_ligne_fichier),'RPERTOIRE DE ')+14));
		DELETE;
	END;

	date_fichier=INPUT(SUBSTR(descr_ligne_fichier,1,10),?? yymmdd10.);

	taille_fichier=INPUT(SCAN(descr_ligne_fichier,3,' '),comma32.);

	nom_fichier=SUBSTR(descr_ligne_fichier,INDEX(descr_ligne_fichier,SCAN(descr_ligne_fichier,4,' ')),900);

	FORMAT date_fichier mmddyy10.;

	/* Tentative de construire tous les niveaux de rpertoires parents pour faciliter le traitement dans Excel... mais a ne marche pas pour l'instant...
	%LET nb_slash = %SYSFUNC(COUNT(repertoire,"\"));
	nbslash = &nb_slash;

	repertoire_niveau1 = CAT(SCAN(repertoire,1,"\"),"\");

	%DO i=2 %TO 5;
	PUT repertoire=;
	%PUT "%CMPRES(repertoire_niveau&i)";
	%PUT %CMPRES(repertoire_niveau%EVAL(&i-1));
	repert = SCAN(repertoire,&i,"\"); PUT repert=;
	IF SCAN(repertoire,&i,"\") NE '' THEN DO;
		%CMPRES(repertoire_niveau&i) = CAT(%CMPRES(repertoire_niveau%EVAL(&i-1)),SCAN(repertoire,&i,"\"),"\");
		PUT %CMPRES(repertoire_niveau&i)=;
	END;

	%END;/**/
RUN;
%MEND;
%construire_liste;

DATA liste_repertoires (KEEP=repert);
	SET work.liste_fichiers_c_lrr ;

	IF _N_ EQ 1 THEN repert = CAT(SCAN(repertoire,1,"\"),"\"); OUTPUT;

	IF SCAN(repertoire,2,"\") NE '' THEN DO; 

		repert = CAT(SCAN(repertoire,1,"\"),"\",SCAN(repertoire,2,"\"),"\"); OUTPUT;
		IF SCAN(repertoire,3,"\") NE '' THEN DO; 
			repert = CAT(SCAN(repertoire,1,"\"),"\",SCAN(repertoire,2,"\"),"\",SCAN(repertoire,3,"\"),"\"); OUTPUT;
			IF SCAN(repertoire,4,"\") NE '' THEN DO; 
				repert = CAT(SCAN(repertoire,1,"\"),"\",SCAN(repertoire,2,"\"),"\",SCAN(repertoire,3,"\"),SCAN(repertoire,4,"\"),"\"); OUTPUT; 
			END;
		END;
	END;
	/*
	repert = SCAN(repertoire,5,"\");
	repert = SCAN(repertoire,6,"\");
	repert = SCAN(repertoire,7,"\");
	repert = SCAN(repertoire,8,"\");
	repert = SCAN(repertoire,9,"\");
	repert = SCAN(repertoire,10,"\");/**/

	IF _N_ GT 30000 THEN STOP;

RUN;
PROC SORT DATA=work.liste_repertoires NODUP; BY repert;


%LET nom_dataset = work.liste_fichiers_c_lrr;
%LET chemin_et_nom_du_fichier = C:\Users\lrrhe\Documents\Fichiers sur mon disque C &RUNDATE..xlsx;
%LET nom_feuille = Liste fichiers;

PROC EXPORT DATA= &nom_dataset
	            OUTFILE= "&chemin_et_nom_du_fichier" 
	            DBMS=EXCEL2007 REPLACE;
				SHEET = "&nom_feuille";
RUN;

%LET nom_dataset = work.liste_repertoires;
%LET chemin_et_nom_du_fichier = C:\Users\lrrhe\Documents\Fichiers sur mon disque C &RUNDATE..xlsx;
%LET nom_feuille = Liste repertoires;

PROC EXPORT DATA= &nom_dataset
	            OUTFILE= "&chemin_et_nom_du_fichier" 
	            DBMS=EXCEL2007 REPLACE;
				SHEET = "&nom_feuille";
RUN;